/*######################################################*/
/* procedure for executing commands (a la execl) with	*/
/* some tracing possible.				*/
/*######################################################*/

#ifdef NOANSI

#include <unistd.h>
#include <stdio.h>
#include <varargs.h>
#include <sys/wait.h>

#define MAXARGS   100

int execute(va_alist)
va_dcl
{
  va_list ap;
  char 	*file;
  char 	*args[MAXARGS];
  int 	argno = 0;
  int	i;
  int	Retval = 0;
  int	Son_PID;

  va_start (ap);
  TOOLNAME = va_arg(ap, char *);
  file = va_arg(ap, char *);
  args[argno++] = file;
  while ((args[argno++] = va_arg(ap, char *)) != (char *)0);
  va_end (ap);

  fprintf(stderr, "%s: Executing %s ", TOOLNAME, file);
  for (i=1; i<argno-1; i++)
    fprintf( stderr, " %s", args[i] );
  fprintf( stderr, "\n");

  if ( 0 == ( Son_PID = fork() ) ) {
    Retval = execv(file, args);
    fprintf( stderr, "%s: Problem executing %s (error=%d)", 
	     TOOLNAME, file, Retval );
    for (i=1; i<argno-1; i++)
      fprintf( stderr, " %s", args[i] );
    fprintf( stderr, "(%d)\n", Retval);
  }
  else
    waitpid( Son_PID, NULL, NULL );

  return	Retval;
}

#else /* gcc with -ansi works ok with this */

#include <stdio.h>		/* includes stdarg.h in turn */
#include <sys/wait.h>
#include <stdarg.h>

#define MAXARGS   100

int execute(char *TOOLNAME, char *file, ...)
{
  va_list 	ap;
  char		*args[MAXARGS];
  int 		argno = 0;
  int		i;
  int		Retval = 0;
  int		Son_PID;

  va_start (ap, file);
  args[argno++] = file;

  while ((args[argno++] = va_arg(ap, char *)) != (char *)0);
  va_end (ap);

  fprintf(stderr, "%s: Executing %s ", TOOLNAME, file);
  for (i=1; i<argno-1; i++)
    fprintf( stderr, " %s", args[i] );
  fprintf( stderr, "\n");
  
  if ( 0 == ( Son_PID = fork() ) ) {

    Retval = execvp(file, args);
    fprintf( stderr, "%s: Problem executing %s (error=%d)", 
	     TOOLNAME, file, Retval );
    for (i=1; i<argno-1; i++)
      fprintf( stderr, " %s", args[i] );
    fprintf( stderr, "(%d)\n", Retval);
  }
  else
    waitpid( Son_PID, NULL, 0 );

  return	Retval;
}

#endif
