/* Data structures useful to several components of ERS			*/

#ifndef _GLOBAL_H
#define _GLOBAL_H

/* inclusion of standard definitions */
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <string.h>

#include "version.h"
#include "parseargs.h"
#include "messages.h"
#include "boolean.h"
#include "real_list.h"
#include "law.h"

/* Constants for Link Types */
#define UNKNOWN_TYPE 0
#define PLATRA	1
#define TRAPLA	2

/* constants useful for printing procedures */
#define NO_CHAR	0
#define PAR	1
#define BRACKET	2
#define QUOTE	3
#define WHITE_QUOTE	4

/* variable globale de debug pour tout le systeme. Correspond a 	*/
/* l'option systematique: -debug					*/
extern boolean Debug;

typedef struct Parametres {
	int	T_Size;
	int	P_Size;
	int	Nb_Firings;
} Parametres;

typedef struct POPULATION {
	int	Pop;
	double	*Delais;
} Population;

typedef struct INT_LIST {
	int		Val;
	struct INT_LIST *Next;
} *Liste_Entier;

typedef struct ADDRESS {
  	char		Type;
  	int		Number;
  	struct ADDRESS	*Next;
} *Address;

typedef struct ADDRESS_LIST {
  	Address		Val;
  	struct ADDRESS_LIST *Next;
} *Liste_Address;

typedef struct ROUTING {
	char	Type;
	double	*Probas;
	int	Period;
	Address	*Cycle;
} *Routing_Desc;

typedef struct LINK_LIST {
  	int		Link_Type;
	int		Dest;
  	Address		A_Dest;
	int		Weight;
	char		*Data;
    	boolean		Is_Inhibitor;
	struct LINK_LIST *Next;
} *Liste_Link;

typedef struct BINDING {
  	Address		From;
  	Address		To;
  	Liste_Link	Link;
  	struct BINDING	*Next;
} *Binding;

#endif
