/* handling of external resources (programs, directories, files...) */
#include <stdio.h>
#define CODE(x)		fprintf( Out_File, x );

int main(int argc, char *argv[])
{
  int	Result;
  int	Nb_Res = 0;
  int	Num_Res = 0;
  FILE	*Res_File;
  FILE	*Out_File;
  char	Field[128];
  char	Trash[128];

  if ( NULL == ( Res_File = fopen( "resources.tab", "r" ) ) ) {
    fprintf( stderr, "%s: cannot open file %s\n",
	     argv[0], "resources.tab" );
    return 1;
  }
  else if ( NULL == ( Out_File = fopen( "resources.h", "w" ) ) ) {
    fprintf( stderr, "%s: cannot open file %s\n",
	     argv[0], "resources.h" );
    return 2;
  }
  else {
    CODE("/* definition file for external resources */\n");
    CODE("#include <stdio.h>\n\n");
    do {
      if ( EOF != ( Result = fscanf( Res_File,
				     "%s %s %s %s",
				     &(Field[0]), &(Trash[0]),
				     &(Trash[0]), &(Trash[0]) ) ) ) {
	fprintf( Out_File, "#define\t%s\t", Field );
	if ( strlen( Field ) < 8 )
	  CODE("\t");
	fprintf( Out_File, "%d\n", Num_Res );
	Num_Res++;
	}
    } while ( EOF != Result );
    CODE("\n");
    Nb_Res = Num_Res;
    fprintf( Out_File, "#define\tNB_RESOURCES\t%d\n", Nb_Res );

    CODE("\n#ifndef RESOURCES\n#define RESOURCES\n\n");

    /* writing down array of resource names */
    fclose( Res_File );
    Res_File = fopen( "resources.tab", "r" );
    CODE("char\t*Resource_Name[] = {\n");
    do {
      if ( EOF != ( Result = fscanf( Res_File,
				     "%s %s %s %s",
				     &(Field[0]), &(Trash[0]),
				     &(Trash[0]), &(Trash[0]) ) ) )
	fprintf( Out_File, "\t\"%s\",\n", Field );

    } while ( EOF != Result );

    CODE("\tNULL };\n\n");

    /* writing down array of access codes */
    fclose( Res_File );
    Res_File = fopen( "resources.tab", "r" );
    Num_Res = 0;
    CODE("#include <unistd.h>\n\n");

    CODE("int\tAccess_Code[] = {\n");
    do {
      if ( EOF != ( Result = fscanf( Res_File,
				     "%s %s %s %s",
				     &(Trash[0]), &(Field[0]),
				     &(Trash[0]), &(Trash[0]) ) ) )
	{	fprintf( Out_File, "\t%s", Field );
	if ( Num_Res < Nb_Res-1 )
	  CODE(",\n");
	Num_Res++;
	}
    } while ( EOF != Result );

    CODE(" };\n\n");

    /* writing down the array of default values */
    fclose( Res_File );
    Res_File = fopen( "resources.tab", "r" );
    CODE("char\t*Default_Value[] = {\n");
    do {
      if ( EOF != ( Result = fscanf( Res_File,
				     "%s %s %s %s",
				     &(Trash[0]), &(Trash[0]),
				     &(Trash[0]), &(Field[0]) ) ) )
	fprintf( Out_File, "\t\"%s\",\n", Field );

    } while ( EOF != Result );

    CODE("\tNULL };\n\n");

    /* writing down array of "essentiality" codes */
    fclose( Res_File );
    Res_File = fopen( "resources.tab", "r" );
    Num_Res = 0;
    CODE("boolean\tIs_Essential[] = {\n");
    do {
      if ( EOF != ( Result = fscanf( Res_File,
				     "%s %s %s %s",
				     &(Trash[0]), &(Trash[0]),
				     &(Field[0]), &(Trash[0]) ) ) )
	{	fprintf( Out_File, "\t%s", Field );
	if ( Num_Res < Nb_Res-1 )
	  CODE(",\n");
	Num_Res++;
	}
    } while ( EOF != Result );

    CODE(" };\n\n");

    CODE("#endif\n");

    /* finished. Wrapping up... */
    fclose( Out_File );

    return 0;
  }
}
