/* TranslationR program from eg language to pn language.	  */

#include "eg.h"

#define	TOOLNAME	"eg2pn"

#define SCAN(x,y)	for(x=y;x!=NULL;x=x->Next)

extern EventGraph	*Read_Network(char*);
extern void		dumpe_network(EventGraph*);
extern void		Free_Event_Graph(EventGraph*);
extern char		*todays_date(void);

/* declaration from transcript.c */
boolean	Write_EG_As_PNL(EventGraph *Reseau, char *File_Name, char *ToolName );

int main(int argc, char	*argv[])
{
  static char		File_Name[128] = "";
  static char		Code_File_Name[128] = "";
  EventGraph 		*Reseau;
  int			i;
  boolean		Help = FALSE;
  boolean		Args_Ok = TRUE;

  i = 1;

  if (argc>1)
    do {
	if GET_STRING( "-f", File_Name )
	else if SWITCH( "-debug", Debug, TRUE )
	else if GET_STRING( "-o", Code_File_Name )
	else if IS_VERSION

	else if ( ( 0 == strcmp( "-h", argv[i] ) )
		  || ( 0 == strcmp( "-?", argv[i] ) ) ) {
	  printf("Usage: %s [-f <file>] ", argv[0]);
	  printf("[-debug] [-o <file>]\n");
	  Args_Ok = FALSE;
	  Help = TRUE;
	  i++;
	}
	else	i++; /* skip unknown argument */
    }
    while ( Args_Ok && ( i < argc ) );

  if ( Args_Ok ) {

    Reseau = Read_Network(File_Name);

    if ( Reseau != NULL ) {
      
      if ( Write_EG_As_PNL(Reseau, Code_File_Name, TOOLNAME) ) {
	Free_Event_Graph( Reseau );

	return 0;
      }
      else {
	return -3;
      }
    }
    else {
      fprintf( stderr, "%s: Error reading network. No translation.\n", 
	       TOOLNAME );	
      return -2;
    }
  }
  else if (!Help)
    return -1;
  else
    return 0;
}
