/* A simple program that reads an EG, performs topological analysis, 	*/
/* and dumps the results.						*/

#include <unistd.h>
#include "version.h"
#include "eg.h"

#define TOOLNAME	"eg_read"

/* external declarations */
extern EventGraph	*Read_Network(char*);
extern boolean		topological_analysis(EventGraph *Reseau);
extern void		dumpe_network(EventGraph *Reseau);
extern void		Free_Event_Graph(EventGraph *Reseau);

int main(int argc, char *argv[])
{	
  static char	File_Name[128] = "";
  EventGraph 	*Reseau;
  int		i;
  boolean	Help = FALSE;
  boolean	Args_Ok = TRUE;
    
  i = 1;

  if (argc>1)
    do {
      if GET_STRING( "-f", File_Name )
      else if IS_VERSION		     

      else if ( ( 0 == strcmp( "-h", argv[i] ) )
		|| ( 0 == strcmp( "-?", argv[i] ) ) ) {
	printf("Usage: %s [-f <file>] [-?] [-h]\n", TOOLNAME );
	Args_Ok = FALSE;
	Help = TRUE;
	i++;
      }
      else
	i++; /* skip unknown argument */
    }
    while ( Args_Ok && ( i < argc ) );
    
  if (Args_Ok) {
	
    Reseau = Read_Network( File_Name );

    if ( Reseau != NULL ) {

      topological_analysis(Reseau);

      dumpe_network(Reseau);

      Free_Event_Graph( Reseau );

      return 0;
    }
    else {
      fprintf( stderr, "%s: Error opening file %s.\n", 
	       TOOLNAME, File_Name );
      return -2;
    }
  }
  else if (!Help) {
    return -1;
  }
  else
    return 0;
}
