#include <stdio.h>

#include "eg.h"
#define RESOURCES
#include "resources.h"

#define TOOLNAME	"m_eg"

/* externs from the resource system */
extern void 	get_resources(boolean);
extern char     **Resource_Value;
extern boolean	*Is_Available;

#define STOP    (char *)0
#define RV(x)   Resource_Value[ x ]


void Seek(
FILE *Result,
char c )
{
  int	In_C;

  do {
    In_C = fgetc( Result );
  } while ( In_C != (int)c );
}

void Extract_Parameters( 
int	Size,
int	Trans_Nb,
int	*T,
int	*D,
double	**B,
double	**Inc )
{
  FILE	*Result;
  char	Value[12];
  int	i, j;
  int	Num;

  Result = fopen( RV( TMP_RES_FILE ), "r" );

  if ( NULL == Result ) {
    fprintf( stderr, "%s: Error: could not open file %s for reading. Abort.\n",
	    TOOLNAME, RV( TMP_RES_FILE ) );
  }
  else {
    Seek( Result, 'C' );
    Seek( Result, 'C' );
    fscanf( Result, "yclicity: cyc = %d", D );
    Seek( Result, 'l' );
    fscanf( Result, "ength of transient period:  %d", T );

    /* start over to read the transient itself */
    fclose( Result );
    Result = fopen( RV( TMP_RES_FILE ), "r" );

    /* memory allocations */
    (*B) = (double*) calloc( (unsigned)(*D), sizeof(double) );
    (*Inc) = (double*) calloc( (unsigned)(*T), sizeof(double) );

    for ( i = 0; i < (*T); i++ ) {
      Seek( Result, 'T' );
      fscanf( Result, " = %d:", &Num );
      if ( Num != i ) {
	fprintf( stderr, "%s: Error: index mismatch (%d<>%d).\n", 
		 TOOLNAME, i, Num );
      }
      for ( j=0; j < Size ; j++ ) {
	fscanf( Result, "%s", Value );
	if ( j == Trans_Nb - 1 ) {
	  /* this is the value we seek */
	  if ( 1 != ( sscanf( Value, "%lf", &((*B)[i]) ) ) ) {
	    fprintf( stderr, "%s: Error: improper value found (%s).\n", 
		     TOOLNAME, Value );
	  }
	}
      }
    }

    /* continuing to read the cyclic part */
    for ( i = 0; i < (*D); i++ ) {
      Seek( Result, 'T' );
      fscanf( Result, " = %d:", &Num );
      for ( j=0; j <= Trans_Nb; j++ ) {
	fscanf( Result, "%s", Value );
	if ( j == Trans_Nb - 1 ) {
	  /* this is the value we seek */
	  if ( 1 != ( sscanf( Value, "%lf", &((*Inc)[i]) ) ) ) {
	    fprintf( stderr, "%s: Error: improper value found (%s).\n", 
		     TOOLNAME, Value );
	  }
	}
      }
    }
  }

  /* readjusting increments */
  for ( i = 0; i < (*D); i++ )
    (*Inc)[i] -= (*B)[(*T)-1];

  /* readjusting transient data */
  for ( i = (*T)-1; i>=0; i-- )
    (*B)[i] -= (*B)[0];

  /* readjusting the "length" of the transient, due to <> conventions */
  (*T)--;
}
