/* Type and Methods Declarations for Random Bernoulli Products of	*/
/* (max,+) matrices.							*/

#ifndef _BERNOULLI_H
#define _BERNOULLI_H

#include <stdio.h>
#include "maxplusmat.h"

typedef struct BERNOULLI_PRODUCT {
  int		Nb_Matrices;
  int		Size;		/* Dimension of matrices 		*/
  MaxPlus_Matrix	*A;	/* Table of matrices 			*/
  double	*Weight;	/* Relat. weights of each matrix. 	*/
  double	*Proba;		/* Probabilities of each matrix. 	*/
  double	*Pr_Cum;        /* Partial Sums of Proba. 		*/
  int		*Permut;	/* Permutation to optimize drawing of 	*/
				/* probas (currently not used)		*/
} *Bernoulli_Product;

typedef struct WEAK_DERIVATIVE {
  int		Size;		/* length of vectors 			*/
  double	C;		/* normalization constant 		*/
  double	*Pr_Cum_Plus;	/* cum. proba vector for "plus" part 	*/
  double	*Pr_Cum_Minus;	/* cum. proba vector for "minus" part 	*/
} *Weak_Derivative;

/* Methods */
Bernoulli_Product New_Bernoulli_Product( int Nb_Matrices, int Matrix_Size );
void Free_Bernoulli_Product( Bernoulli_Product );
Bernoulli_Product Read_Bernoulli_Product( FILE* Input );
void Write_Bernoulli_Product(Bernoulli_Product,FILE*,int,char*);

#endif
