/* Declaration of boolean matrice structures and methods */

#ifndef _BOOLMAT_H
#define _BOOLMAT_H

#include <stdio.h>
#include "boolean.h"

/* Declaration of matrix structures */
#ifdef USE_SP_BOOL_MATRICES
typedef struct SP_BOOL_MAT {
  int	Size;
  int 	*Nb_Elts;	/* For each i, nb of "outputs" 			*/
  int	**Elts;		/* For each i, table of the j's connected. 	*/
} *SP_Bool_Mat;

#define Boolean_Matrix	SP_Bool_Mat
#else
typedef struct FULL_BOOL_MAT {
  int	Size;
  int	**Vals;
} *Full_Bool_Mat;

#define Boolean_Matrix	Full_Bool_Mat
#endif

Boolean_Matrix New_Boolean_Matrix(int);
void Free_Boolean_Matrix(Boolean_Matrix);
void Set_Adj(Boolean_Matrix A,int From,int To,int Val);
boolean Is_Adj(Boolean_Matrix A,int From,int To);
void Write_Boolean_Matrix(Boolean_Matrix,FILE*);
int Max_Degree(Boolean_Matrix);
double Avg_Degree(Boolean_Matrix);

#endif
