/* Definitions related to (maxplus) full matrix manipulations */

#ifndef _FULLMAT_H
#define _FULLMAT_H

/* types of matrices for initialization */
#define NONE		0
#define	ZERO		1
#define	IDENTITY	2
#define	ONE		3

typedef struct FULL_MAXPLUS_MATRIX {
  int		Rows;
  int		Cols;
  double 	**Vals;
} *Full_MaxPlus_Matrix;

Full_MaxPlus_Matrix New_Full_MaxPlus_Matrix(int Rows,int Cols,int Mode);
void Free_Full_MaxPlus_Matrix(Full_MaxPlus_Matrix A);
boolean Init_Full_MaxPlus_Matrix(Full_MaxPlus_Matrix,int);
Full_MaxPlus_Matrix Make_Full_MaxPlus_Matrix(int,int,double **);
Full_MaxPlus_Matrix Copy_Full_MaxPlus_Matrix(Full_MaxPlus_Matrix);
double Get_Full_Matrix_Entry(Full_MaxPlus_Matrix,int,int);
boolean Set_Full_Matrix_Entry(Full_MaxPlus_Matrix,int,int,double);
boolean Full_Read_Full_Matrix_Entry(FILE*,Full_MaxPlus_Matrix,int,int);
boolean Full_Read_Full_Matrix(FILE*,Full_MaxPlus_Matrix);
boolean Full_Read_MaxPlus_Matrix(FILE*,Full_MaxPlus_Matrix);
void Write_Full_MaxPlus_Matrix(Full_MaxPlus_Matrix,FILE*,int,char*);
void Full_MM_Mult(Full_MaxPlus_Matrix,Full_MaxPlus_Matrix,
		  Full_MaxPlus_Matrix);
void Full_MM_Sum(Full_MaxPlus_Matrix,Full_MaxPlus_Matrix,
		 Full_MaxPlus_Matrix);
void Full_MM_Standard_Sum(Full_MaxPlus_Matrix,Full_MaxPlus_Matrix,
			  Full_MaxPlus_Matrix);
void Full_Standard_Scalar_Product(Full_MaxPlus_Matrix,Full_MaxPlus_Matrix,
				     double);
double Full_Matrix_Norm(Full_MaxPlus_Matrix);
double Full_Matrix_Min(Full_MaxPlus_Matrix);

#endif
