/* Definitions related to (real) sparse matrix manipulations */

typedef struct SP_REAL_MATRIX {
  int		Size;
  int		*Nb_Elts; 	/* Table of numbers of elements in rows */
  int		**Elts;		/* Ids of neighboring states		*/
  double	**Vals;		/* Values associated.			*/
} *SP_Real_Matrix;

SP_Real_Matrix New_SP_Real_Matrix(int	Size);
double Row_Sum(SP_Real_Matrix,int);
boolean Set_Sparse_Matrix_Entry(SP_Real_Matrix,int,int,double);
boolean Add_To_Sparse_Matrix_Entry(SP_Real_Matrix,int,int,double);
double  Get_Sparse_Matrix_Entry(SP_Real_Matrix,int,int);
boolean Read_Full_Matrix_Entry(FILE*,SP_Real_Matrix,int,int);
boolean Read_Sparse_Matrix_Entry(FILE*,SP_Real_Matrix);
void Write_Matrix(FILE*,SP_Real_Matrix,boolean);
