%{
extern double atof(const char*);
extern int    atoi(const char*);
extern char   *strncpy(char *, const char*, size_t);

int	PNL_lineno = 1;
%}

%%
Transitions	return( TSIZE );
Places		return( PSIZE );
Duree		return( TMAX );
Length		return( TMAX );
Name		return( NAME );
Submodel	return( SUBM );
FILE|File|file	return( INFILE );
Is|is|IS	return( IS );
Export		return( EXPORT );
Bindings|Binding	return( BIND );
In|in|IN	return( IN );
Out|out|OUT	return( OUT );
REP		return( REP );
Random		return( RAND );
Cyclic		return( CYCL );
Competition	return( COMP );
Priority	return( PRIO );
B		return( BERN );
C		return( CST  );
D		return( DISC );
E		return( EXPO );
G		return( GEOM1 );
g		return( GEOM0 );
H		return( HEXP );
L		return( LOGNO );
O		return( ONOFF );
p		return( PARETO );
IPP		return( IPP );
R		return( ERLG );
U		return( UNIF );
W		return( WEIBULL );
T		return( TRANS );
P		return( PLACE );
S		return( SUBMO );
I		return( INHIB );
\<\-		return( AFFECT );
\[		return( PARB );
\]		return( PARE );
\/		return( SLASH );
[0-9]+		{
			yylval.ival = atoi(yytext);
			return( INTGR );
		}
[0-9]+\.[0-9]*	{
			yylval.rval = atof(yytext);
			return( REAL );
		}
\"[^\"\n]*\"	{
			/* printf("Got string (%s)\n", yytext ); */
			yylval.sval = malloc( (yyleng-1)*sizeof(char) );
			yylval.sval = strncpy( yylval.sval, &(yytext[1]),
						yyleng-2 );
			yylval.sval[yyleng-2] = '\0';

			return( STRING );
		}
[,]		return( SEP );
\;		return( ENDINSTR );
#.*$		;
[ \t]+		;
[\n]		{
                        PNL_lineno++;
                };
.		printf("Illegal character: %s\n", yytext);
