/* File for the Equational simulation of a Petri net 		*/
/* generated by pn2mixt version v6.1				*/
/* Date:  08 May 97 at 18:39:46 				*/

#include <stdio.h>
#include <iostream.h>
#include <MLCG.h>
#include <Uniform.h>
#include "Routing_Server.hh"

int     TMAX = 100;
int     SCALE = 1;
#define NB_TRANS	16
#define NB_PLACES	10
#define NB_MAX_DEPT	256
#define BUF_SIZE	102
#define HALF_BUF_SIZE	51
#define Infinity	0x7FFFFFFF

#define MIN(x,y)    ( x<y?x:y )

#define MAX_DELAY	1
#define MAX_OUTDEGREE	2
#define CL_P0_T0	17
#define CL_P2_T8	18
#define CL_P3_T9	19
#define NB_P0_TO_T0	0
#define NB_P1_TO_T10	0
#define NB_P1_TO_T11	1
#define NB_P2_TO_T8	0
#define NB_P3_TO_T9	0
#define NB_P5_TO_T14	0
#define NB_P5_TO_T11	1
#define NB_P8_TO_T13	0
#define NB_P8_TO_T10	1
#define NB_P9_TO_T13	0
#define NB_P9_TO_T14	1

/* external declarations from the Prosit part */
extern bool	Trace;
extern Routing_Server	*Place_0;
extern Routing_Server	*Place_7;

/* table Y of initiated firings				*/
int     Y[BUF_SIZE][NB_TRANS];
/* table Z of completed firings				*/
int     Z[BUF_SIZE][NB_TRANS];
int     Nb_Tokens;
/* table of initial availabilities				*/
int			Avail[NB_PLACES][MAX_DELAY] = {
	 1,
	10,
	 1,
	 1,
	 0,
	 0,
	 0,
	 1,
	 0,
	10
};

/* table of firing times					*/
int			Fire_Time[NB_TRANS] = {
	 1,
	 1,
	 0,
	 0,
	 0,
	 0,
	 0,
	 0,
	 0,
	 0,
	 0,
	 0,
	 0,
	 0,
	 0,
	 1
};

/* table of source flags					*/
int			Is_Source[NB_TRANS] = {
	FALSE,
	FALSE,
	TRUE,
	TRUE,
	TRUE,
	TRUE,
	TRUE,
	TRUE,
	FALSE,
	FALSE,
	FALSE,
	FALSE,
	FALSE,
	FALSE,
	FALSE,
	FALSE
};

/* table of transition names					*/
char			*Trans_Name[NB_TRANS] = {
	"PROSIT t1_out",
	"transition.17",
	"PROSIT|t1.0",
	"PROSIT|t1.1",
	"PROSIT|t1.2",
	"PROSIT|t4.0",
	"PROSIT|t4.1",
	"PROSIT|t4.2",
	" t1_in",
	" t4_in",
	"ts1",
	"ts2",
	"PROSIT|t2_out",
	"ts3",
	"ts4",
	"transition.41",

};

/* variable for computing enabling degree of transitions */
int	E_Degree;
/* variables for use with the circular buffer				*/
int	Real_EQ_Time = 0;
int	EQ_Time = 0;		/* The time, modulo the buffer size	*/
int	EQ_Time_M_1;	/* Time - 1 */

int	*Y_0;		/* Y[ EQ_Time ] */
int	*Y_Time_M_1;	/* Y[ EQ_Time - 1 ] */

/* tables and counts for routing generation			*/
int H_0[BUF_SIZE][MAX_OUTDEGREE];
int Count_1 = 0;
double P_Proba_1[2] = { 0.5000, 1.0 };
int Dest_1[2] = { 10, 11 };
int H_1[BUF_SIZE][MAX_OUTDEGREE];
int H_2[BUF_SIZE][MAX_OUTDEGREE];
int H_3[BUF_SIZE][MAX_OUTDEGREE];
int Count_5 = 0;
double P_Proba_5[2] = { 0.5000, 1.0 };
int Dest_5[2] = { 14, 11 };
int H_5[BUF_SIZE][MAX_OUTDEGREE];
int Count_8 = 0;
double P_Proba_8[2] = { 0.5000, 1.0 };
int Dest_8[2] = { 13, 10 };
int H_8[BUF_SIZE][MAX_OUTDEGREE];
int Count_9 = 0;
double P_Proba_9[2] = { 0.5000, 1.0 };
int Dest_9[2] = { 13, 14 };
int H_9[BUF_SIZE][MAX_OUTDEGREE];


/* Declarations for random number generation(for routing and sources)*/
Uniform *U_0_1 = new Uniform( 0.0, 1.0, new MLCG( 12, 123 ) );

/* Declaration of procedures for collecting statistics on the	*/
/* EQ object.							*/
void Compute_Stat( ) {
}

void Report_Stat( ostream &Out_File ) {

  int	Final_Time = Real_EQ_Time - 1;
  int	Final_EQ_Time = Final_Time % BUF_SIZE;

  Out_File << "--------------------------------------------------" << endl;
  Out_File << " Station Transition : PROSIT t1_out #EQ/0   t=";
  Out_File << Final_Time << endl << endl;
  Out_File << " Mean inter-departure time    : ";
  Out_File << (double)Z[Final_EQ_Time][0] / (double)Final_Time;
  Out_File << endl;
  Out_File << " Number of services : ";
  Out_File << Z[Final_EQ_Time][0] << endl;

  Out_File << "--------------------------------------------------" << endl;
  Out_File << " Station Transition : transition.17 #EQ/1   t=";
  Out_File << Final_Time << endl << endl;
  Out_File << " Mean inter-departure time    : ";
  Out_File << (double)Z[Final_EQ_Time][1] / (double)Final_Time;
  Out_File << endl;
  Out_File << " Number of services : ";
  Out_File << Z[Final_EQ_Time][1] << endl;

  Out_File << "--------------------------------------------------" << endl;
  Out_File << " Station Transition :  t1_in #EQ/8   t=";
  Out_File << Final_Time << endl << endl;
  Out_File << " Mean inter-departure time    : ";
  Out_File << (double)Z[Final_EQ_Time][8] / (double)Final_Time;
  Out_File << endl;
  Out_File << " Number of services : ";
  Out_File << Z[Final_EQ_Time][8] << endl;

  Out_File << "--------------------------------------------------" << endl;
  Out_File << " Station Transition :  t4_in #EQ/9   t=";
  Out_File << Final_Time << endl << endl;
  Out_File << " Mean inter-departure time    : ";
  Out_File << (double)Z[Final_EQ_Time][9] / (double)Final_Time;
  Out_File << endl;
  Out_File << " Number of services : ";
  Out_File << Z[Final_EQ_Time][9] << endl;

  Out_File << "--------------------------------------------------" << endl;
  Out_File << " Station Transition : ts1 #EQ/10   t=";
  Out_File << Final_Time << endl << endl;
  Out_File << " Mean inter-departure time    : ";
  Out_File << (double)Z[Final_EQ_Time][10] / (double)Final_Time;
  Out_File << endl;
  Out_File << " Number of services : ";
  Out_File << Z[Final_EQ_Time][10] << endl;

  Out_File << "--------------------------------------------------" << endl;
  Out_File << " Station Transition : ts2 #EQ/11   t=";
  Out_File << Final_Time << endl << endl;
  Out_File << " Mean inter-departure time    : ";
  Out_File << (double)Z[Final_EQ_Time][11] / (double)Final_Time;
  Out_File << endl;
  Out_File << " Number of services : ";
  Out_File << Z[Final_EQ_Time][11] << endl;

  Out_File << "--------------------------------------------------" << endl;
  Out_File << " Station Transition : ts3 #EQ/13   t=";
  Out_File << Final_Time << endl << endl;
  Out_File << " Mean inter-departure time    : ";
  Out_File << (double)Z[Final_EQ_Time][13] / (double)Final_Time;
  Out_File << endl;
  Out_File << " Number of services : ";
  Out_File << Z[Final_EQ_Time][13] << endl;

  Out_File << "--------------------------------------------------" << endl;
  Out_File << " Station Transition : ts4 #EQ/14   t=";
  Out_File << Final_Time << endl << endl;
  Out_File << " Mean inter-departure time    : ";
  Out_File << (double)Z[Final_EQ_Time][14] / (double)Final_Time;
  Out_File << endl;
  Out_File << " Number of services : ";
  Out_File << Z[Final_EQ_Time][14] << endl;

  Out_File << "--------------------------------------------------" << endl;
  Out_File << " Station Transition : transition.41 #EQ/15   t=";
  Out_File << Final_Time << endl << endl;
  Out_File << " Mean inter-departure time    : ";
  Out_File << (double)Z[Final_EQ_Time][15] / (double)Final_Time;
  Out_File << endl;
  Out_File << " Number of services : ";
  Out_File << Z[Final_EQ_Time][15] << endl;

}

/* Procedure for incrementing the firing count vector	*/
/* Version to handle initial firings			*/
void Increment_Initial()
{
  static int	j;
  static int	Tmp_Y;
  static double	U;

  /* Copy present firing count for everybody  */
  Y[EQ_Time][0] = ( EQ_Time>0 ? Y[EQ_Time-1][0] : 0 );
  Y[EQ_Time][1] = ( EQ_Time>0 ? Y[EQ_Time-1][1] : 0 );
  Y[EQ_Time][8] = ( EQ_Time>0 ? Y[EQ_Time-1][8] : 0 );
  Y[EQ_Time][9] = ( EQ_Time>0 ? Y[EQ_Time-1][9] : 0 );
  Y[EQ_Time][10] = ( EQ_Time>0 ? Y[EQ_Time-1][10] : 0 );
  Y[EQ_Time][11] = ( EQ_Time>0 ? Y[EQ_Time-1][11] : 0 );
  Y[EQ_Time][13] = ( EQ_Time>0 ? Y[EQ_Time-1][13] : 0 );
  Y[EQ_Time][14] = ( EQ_Time>0 ? Y[EQ_Time-1][14] : 0 );
  Y[EQ_Time][15] = ( EQ_Time>0 ? Y[EQ_Time-1][15] : 0 );

  /* Computing the 10 transitions with time scale 1 */
  /* Evolution of transition PROSIT t1_out */
  Nb_Tokens = H_0[EQ_Time][ NB_P0_TO_T0 ];
  Y[EQ_Time][0] = Nb_Tokens;

  /* Evolution of transition  t1_in */
  Nb_Tokens = H_2[EQ_Time][ NB_P2_TO_T8 ];
  Y[EQ_Time][8] = Nb_Tokens;

  /* Evolution of transition  t4_in */
  Nb_Tokens = H_3[EQ_Time][ NB_P3_TO_T9 ];
  Y[EQ_Time][9] = Nb_Tokens;

  /* Evolution of transition ts1 */
  Tmp_Y = Infinity;
  /* Computing number of tokens arrived in place 8 (sw2) */
  Nb_Tokens = Avail[8][EQ_Time];
  Nb_Tokens += ( EQ_Time >= 0 ? Y[EQ_Time-0][8]  : 0 );
  /* Computing the number of tokens routed from place 8 (sw2) */
  for( ; Count_8 < Nb_Tokens; Count_8++ ) {
    U = (*U_0_1)();
    for( j=0; U > P_Proba_8[j]; j++ );
    H_8[EQ_Time][ j ]++;
  }
  Nb_Tokens = H_8[EQ_Time][ NB_P8_TO_T10 ];
  Tmp_Y = MIN( Tmp_Y, Nb_Tokens );
  /* Computing number of tokens arrived in place 1 (capa_switch) */
  Nb_Tokens = Avail[1][EQ_Time];
  Nb_Tokens += ( EQ_Time >= 1 ? Y[EQ_Time-1][1]  : 0 );
  /* Computing the number of tokens routed from place 1 (capa_switch) */
  for( ; Count_1 < Nb_Tokens; Count_1++ ) {
    U = (*U_0_1)();
    for( j=0; U > P_Proba_1[j]; j++ );
    H_1[EQ_Time][ j ]++;
  }
  Nb_Tokens = H_1[EQ_Time][ NB_P1_TO_T10 ];
  Tmp_Y = MIN( Tmp_Y, Nb_Tokens );
  Y[EQ_Time][10] = Tmp_Y;

  /* Evolution of transition ts2 */
  Tmp_Y = Infinity;
  /* Computing number of tokens arrived in place 5 ( sw1) */
  Nb_Tokens = Avail[5][EQ_Time];
  Nb_Tokens += ( EQ_Time >= 0 ? Y[EQ_Time-0][9]  : 0 );
  /* Computing the number of tokens routed from place 5 ( sw1) */
  for( ; Count_5 < Nb_Tokens; Count_5++ ) {
    U = (*U_0_1)();
    for( j=0; U > P_Proba_5[j]; j++ );
    H_5[EQ_Time][ j ]++;
  }
  Nb_Tokens = H_5[EQ_Time][ NB_P5_TO_T11 ];
  Tmp_Y = MIN( Tmp_Y, Nb_Tokens );
  Nb_Tokens = Count_1;
  Nb_Tokens = H_1[EQ_Time][ NB_P1_TO_T11 ];
  Tmp_Y = MIN( Tmp_Y, Nb_Tokens );
  Y[EQ_Time][11] = Tmp_Y;

  /* Evolution of transition ts3 */
  Tmp_Y = Infinity;
  /* Computing number of tokens arrived in place 9 (place.25) */
  Nb_Tokens = Avail[9][EQ_Time];
  Nb_Tokens += ( EQ_Time >= 1 ? Y[EQ_Time-1][15]  : 0 );
  /* Computing the number of tokens routed from place 9 (place.25) */
  for( ; Count_9 < Nb_Tokens; Count_9++ ) {
    U = (*U_0_1)();
    for( j=0; U > P_Proba_9[j]; j++ );
    H_9[EQ_Time][ j ]++;
  }
  Nb_Tokens = H_9[EQ_Time][ NB_P9_TO_T13 ];
  Tmp_Y = MIN( Tmp_Y, Nb_Tokens );
  Nb_Tokens = Count_8;
  Nb_Tokens = H_8[EQ_Time][ NB_P8_TO_T13 ];
  Tmp_Y = MIN( Tmp_Y, Nb_Tokens );
  Y[EQ_Time][13] = Tmp_Y;

  /* Evolution of transition ts4 */
  Tmp_Y = Infinity;
  Nb_Tokens = Count_9;
  Nb_Tokens = H_9[EQ_Time][ NB_P9_TO_T14 ];
  Tmp_Y = MIN( Tmp_Y, Nb_Tokens );
  Nb_Tokens = Count_5;
  Nb_Tokens = H_5[EQ_Time][ NB_P5_TO_T14 ];
  Tmp_Y = MIN( Tmp_Y, Nb_Tokens );
  Y[EQ_Time][14] = Tmp_Y;

  /* Evolution of transition transition.17 */
  /* Computing number of tokens arrived in place 4 (place.13) */
  Nb_Tokens = Avail[4][EQ_Time];
  Nb_Tokens += ( EQ_Time >= 1 ? Y[EQ_Time-1][11]  : 0 );
  Nb_Tokens += ( EQ_Time >= 1 ? Y[EQ_Time-1][10]  : 0 );
  Y[EQ_Time][1] = Nb_Tokens;

  /* Evolution of transition transition.41 */
  /* Computing number of tokens arrived in place 6 (place.16) */
  Nb_Tokens = Avail[6][EQ_Time];
  Nb_Tokens += ( EQ_Time >= 1 ? Y[EQ_Time-1][14]  : 0 );
  Nb_Tokens += ( EQ_Time >= 1 ? Y[EQ_Time-1][13]  : 0 );
  Y[EQ_Time][15] = Nb_Tokens;

  /* computing the number of completed firings */
  Z[EQ_Time][0] = ( EQ_Time >= 1 ? Y[EQ_Time-1][0] : 0 );
  Z[EQ_Time][1] = ( EQ_Time >= 1 ? Y[EQ_Time-1][1] : 0 );
  Z[EQ_Time][8] = Y[EQ_Time][8];
  Z[EQ_Time][9] = Y[EQ_Time][9];
  Z[EQ_Time][10] = Y[EQ_Time][10];
  Z[EQ_Time][11] = Y[EQ_Time][11];
  Z[EQ_Time][13] = Y[EQ_Time][13];
  Z[EQ_Time][14] = Y[EQ_Time][14];
  Z[EQ_Time][15] = ( EQ_Time >= 1 ? Y[EQ_Time-1][15] : 0 );

} /* end of loop code */

/* Procedure for incrementing the firing count vector	*/
/* Version to handle regular firings			*/
void Increment_Regular()
{
  static int	j;
  static int	Tmp_Y;
  static double	U;

  /* Copy present firing count for everybody  */
  Y_0[0] = Y_Time_M_1[0];
  Y_0[1] = Y_Time_M_1[1];
  Y_0[8] = Y_Time_M_1[8];
  Y_0[9] = Y_Time_M_1[9];
  Y_0[10] = Y_Time_M_1[10];
  Y_0[11] = Y_Time_M_1[11];
  Y_0[13] = Y_Time_M_1[13];
  Y_0[14] = Y_Time_M_1[14];
  Y_0[15] = Y_Time_M_1[15];

  /* Computing the 10 transitions with time scale 1 */
  /* Evolution of transition PROSIT t1_out */
  Nb_Tokens = H_0[EQ_Time][ NB_P0_TO_T0 ];
  Y_0[0] = Nb_Tokens;

  /* Evolution of transition  t1_in */
  Nb_Tokens = H_2[EQ_Time][ NB_P2_TO_T8 ];
  Y_0[8] = Nb_Tokens;

  /* Evolution of transition  t4_in */
  Nb_Tokens = H_3[EQ_Time][ NB_P3_TO_T9 ];
  Y_0[9] = Nb_Tokens;

  /* Evolution of transition ts1 */
  Tmp_Y = Infinity;
  /* Computing number of tokens arrived in place 8 (sw2) */
  Nb_Tokens = 0;
  Nb_Tokens += Y_0[8];
  /* Computing the number of tokens routed from place 8 (sw2) */
  for( ; Count_8 < Nb_Tokens; Count_8++ ) {
    U = (*U_0_1)();
    for( j=0; U > P_Proba_8[j]; j++ );
    H_8[EQ_Time][ j ]++;
  }
  Nb_Tokens = H_8[EQ_Time][ NB_P8_TO_T10 ];
  Tmp_Y = MIN( Tmp_Y, Nb_Tokens );
  /* Computing number of tokens arrived in place 1 (capa_switch) */
  Nb_Tokens = 10;
  Nb_Tokens += Y_Time_M_1[1];
  /* Computing the number of tokens routed from place 1 (capa_switch) */
  for( ; Count_1 < Nb_Tokens; Count_1++ ) {
    U = (*U_0_1)();
    for( j=0; U > P_Proba_1[j]; j++ );
    H_1[EQ_Time][ j ]++;
  }
  Nb_Tokens = H_1[EQ_Time][ NB_P1_TO_T10 ];
  Tmp_Y = MIN( Tmp_Y, Nb_Tokens );
  Y_0[10] = Tmp_Y;

  /* Evolution of transition ts2 */
  Tmp_Y = Infinity;
  /* Computing number of tokens arrived in place 5 ( sw1) */
  Nb_Tokens = 0;
  Nb_Tokens += Y_0[9];
  /* Computing the number of tokens routed from place 5 ( sw1) */
  for( ; Count_5 < Nb_Tokens; Count_5++ ) {
    U = (*U_0_1)();
    for( j=0; U > P_Proba_5[j]; j++ );
    H_5[EQ_Time][ j ]++;
  }
  Nb_Tokens = H_5[EQ_Time][ NB_P5_TO_T11 ];
  Tmp_Y = MIN( Tmp_Y, Nb_Tokens );
  Nb_Tokens = Count_1;
  Nb_Tokens = H_1[EQ_Time][ NB_P1_TO_T11 ];
  Tmp_Y = MIN( Tmp_Y, Nb_Tokens );
  Y_0[11] = Tmp_Y;

  /* Evolution of transition ts3 */
  Tmp_Y = Infinity;
  /* Computing number of tokens arrived in place 9 (place.25) */
  Nb_Tokens = 10;
  Nb_Tokens += Y_Time_M_1[15];
  /* Computing the number of tokens routed from place 9 (place.25) */
  for( ; Count_9 < Nb_Tokens; Count_9++ ) {
    U = (*U_0_1)();
    for( j=0; U > P_Proba_9[j]; j++ );
    H_9[EQ_Time][ j ]++;
  }
  Nb_Tokens = H_9[EQ_Time][ NB_P9_TO_T13 ];
  Tmp_Y = MIN( Tmp_Y, Nb_Tokens );
  Nb_Tokens = Count_8;
  Nb_Tokens = H_8[EQ_Time][ NB_P8_TO_T13 ];
  Tmp_Y = MIN( Tmp_Y, Nb_Tokens );
  Y_0[13] = Tmp_Y;

  /* Evolution of transition ts4 */
  Tmp_Y = Infinity;
  Nb_Tokens = Count_9;
  Nb_Tokens = H_9[EQ_Time][ NB_P9_TO_T14 ];
  Tmp_Y = MIN( Tmp_Y, Nb_Tokens );
  Nb_Tokens = Count_5;
  Nb_Tokens = H_5[EQ_Time][ NB_P5_TO_T14 ];
  Tmp_Y = MIN( Tmp_Y, Nb_Tokens );
  Y_0[14] = Tmp_Y;

  /* Evolution of transition transition.17 */
  /* Computing number of tokens arrived in place 4 (place.13) */
  Nb_Tokens = 0;
  Nb_Tokens += Y_Time_M_1[11];
  Nb_Tokens += Y_Time_M_1[10];
  Y_0[1] = Nb_Tokens;

  /* Evolution of transition transition.41 */
  /* Computing number of tokens arrived in place 6 (place.16) */
  Nb_Tokens = 0;
  Nb_Tokens += Y_Time_M_1[14];
  Nb_Tokens += Y_Time_M_1[13];
  Y_0[15] = Nb_Tokens;

  /* computing the number of completed firings */
  Z[EQ_Time][0] = Y[EQ_Time_M_1][0];
  Z[EQ_Time][1] = Y[EQ_Time_M_1][1];
  Z[EQ_Time][8] = Y[EQ_Time][8];
  Z[EQ_Time][9] = Y[EQ_Time][9];
  Z[EQ_Time][10] = Y[EQ_Time][10];
  Z[EQ_Time][11] = Y[EQ_Time][11];
  Z[EQ_Time][13] = Y[EQ_Time][13];
  Z[EQ_Time][14] = Y[EQ_Time][14];
  Z[EQ_Time][15] = Y[EQ_Time_M_1][15];

} /* end of loop code */

/* Procedure for incrementing the firing count vector		*/
/* Switch according to what time it is...			*/
void Increment( )
{
  if ( Real_EQ_Time >= 1 )
    Increment_Regular();
  else
    Increment_Initial();

  /* Increment of the time variables */
  Real_EQ_Time ++;
  EQ_Time = ( EQ_Time + 1 ) % BUF_SIZE;
  EQ_Time_M_1 = ( EQ_Time + 101 ) % BUF_SIZE;
  Y_0 = Y[ EQ_Time ];
  Y_Time_M_1 = Y[ EQ_Time_M_1 ];

  /* Setting up routing information */
  H_0[EQ_Time][ NB_P0_TO_T0 ] = H_0[EQ_Time_M_1][ NB_P0_TO_T0 ];
  H_1[EQ_Time][ NB_P1_TO_T10 ] = H_1[EQ_Time_M_1][ NB_P1_TO_T10 ];
  H_1[EQ_Time][ NB_P1_TO_T11 ] = H_1[EQ_Time_M_1][ NB_P1_TO_T11 ];
  H_2[EQ_Time][ NB_P2_TO_T8 ] = H_2[EQ_Time_M_1][ NB_P2_TO_T8 ];
  H_3[EQ_Time][ NB_P3_TO_T9 ] = H_3[EQ_Time_M_1][ NB_P3_TO_T9 ];
  H_5[EQ_Time][ NB_P5_TO_T14 ] = H_5[EQ_Time_M_1][ NB_P5_TO_T14 ];
  H_5[EQ_Time][ NB_P5_TO_T11 ] = H_5[EQ_Time_M_1][ NB_P5_TO_T11 ];
  H_8[EQ_Time][ NB_P8_TO_T13 ] = H_8[EQ_Time_M_1][ NB_P8_TO_T13 ];
  H_8[EQ_Time][ NB_P8_TO_T10 ] = H_8[EQ_Time_M_1][ NB_P8_TO_T10 ];
  H_9[EQ_Time][ NB_P9_TO_T13 ] = H_9[EQ_Time_M_1][ NB_P9_TO_T13 ];
  H_9[EQ_Time][ NB_P9_TO_T14 ] = H_9[EQ_Time_M_1][ NB_P9_TO_T14 ];
}

/* Procedure for incrementing the firing count vector	*/
/* due to arrivals from the Prosit part of the network	*/
void Arrival( int The_Class, double PROSIT_Time )
{

  switch( The_Class ) {
    case CL_P0_T0:
      H_0[EQ_Time][ NB_P0_TO_T0 ] ++;
      if ( Trace )
        printf("+++ Arrival at transition #1 (PROSIT t1_out)\n");
    break;
    case CL_P2_T8:
      H_2[EQ_Time][ NB_P2_TO_T8 ] ++;
      if ( Trace )
        printf("+++ Arrival at transition #9 ( t1_in)\n");
    break;
    case CL_P3_T9:
      H_3[EQ_Time][ NB_P3_TO_T9 ] ++;
      if ( Trace )
        printf("+++ Arrival at transition #10 ( t4_in)\n");
    break;
  } /* end of switch */

}

/* Procedure for incrementing the firing count vector	*/
/* due to arrivals from the Prosit part of the network	*/
int	Prepare_New_Batch = TRUE;

Routing_Server *Next_Departure( )
{

  static int		Nb_Departures;
  static int		Index;
  static Routing_Server	*Dpt[NB_MAX_DEPT];
  int			Dp_Time;
  int			Dp_Time_M_1;

  if ( Prepare_New_Batch ) {
    Prepare_New_Batch = FALSE;
    Nb_Departures = 0;
    /* get --exact-- time */;
    Dp_Time = EQ_Time_M_1;
    Dp_Time_M_1 = ( Dp_Time + 101 ) % BUF_SIZE;

    /* departures from transition #1 (transition.17) */
    for ( Index = Z[Dp_Time_M_1][1];
          ( Index < Z[Dp_Time][1] ) && ( Nb_Departures < NB_MAX_DEPT );
          Index++ ) {
      Dpt[ Nb_Departures ] = Place_0;
      Nb_Departures++;
      if ( Trace )
        printf("+++ Departure from trans #2 (transition.17) to place #1 (PROSIT|place1_out)\n");
    }
    /* departures from transition #15 (transition.41) */
    for ( Index = Z[Dp_Time_M_1][15];
          ( Index < Z[Dp_Time][15] ) && ( Nb_Departures < NB_MAX_DEPT );
          Index++ ) {
      Dpt[ Nb_Departures ] = Place_7;
      Nb_Departures++;
      if ( Trace )
        printf("+++ Departure from trans #16 (transition.41) to place #8 (PROSIT|place2_out)\n");
    }
    if ( Nb_Departures >= NB_MAX_DEPT ) {
      printf("warning: max number of simultaneous departures exceeded.
	Some departures ignored.\n");
    }

  Index = 0;
  }
  if ( Index == Nb_Departures ) {
    Prepare_New_Batch = TRUE;
    Index++;
    return 0;
  }
  else {
    Index++;
    return Dpt[ Index - 1 ];
  }

}


void Init( )
{
}


void Terminate( )
{
}

