/* Translation program from pn language to pn language.	  */

#include "pn.h"

#define	TOOLNAME	"pn2pn"

#define SCAN(x,y)	for(x=y;x!=NULL;x=x->Next)

extern PetriNet		*Read_Network( char *File_Name );
extern void		dumpe_network( PetriNet *Reseau );
extern char		*todays_date( void );
extern boolean		Write_PN_As_PNL( PetriNet* Reseau, char *File_Name,
					 char *Tool_Name );
extern int		Find_Type( PetriNet *Reseau, Address Addr );
extern Address		Expand_Address( PetriNet* Reseau, Address Addr );

/* external declaration from the module flatten.c */
extern PetriNet	*Flatten_PN( PetriNet* Reseau, boolean	Expand_Names );
/* forward declarations */
void		Determinize_PN( PetriNet* Reseau );

int main(
int	argc,
char	*argv[] )
{
  static char		File_Name[128] = "";
  static char		Code_File_Name[128] = "";
  PetriNet 		*Reseau;
  int			i;
  boolean		Determinize = FALSE;
  boolean		Flatten = FALSE;
  boolean		Expand_Names = TRUE;
  boolean		Help = FALSE;
  boolean		Args_Ok = TRUE;

  i = 1;

  if (argc>1)
    do {

      if GET_STRING( "-f", File_Name )
      else if GET_STRING( "-o", Code_File_Name )

      else if SWITCH( "-determinize", Determinize, TRUE )
      else if SWITCH( "-flatten", Flatten, TRUE )
      else if SWITCH( "-noExpandNames", Expand_Names, FALSE )
      else if SWITCH( "-debug", Debug, TRUE )

      else if IS_VERSION

      else if ( ( 0 == strcmp( "-h", argv[i] ) )
		|| ( 0 == strcmp( "-?", argv[i] ) ) ) {
	printf("Usage: %s [-f <file>] [-determinize] ", TOOLNAME );
	printf("[-flatten] [-noExpandNames]\n\t[-o <file>] [-debug] ");
	printf("[-h] [-?]\n");
	Args_Ok = FALSE;
	Help = TRUE;
	i++;
      }

      else
	i++; /* skip unknown argument */
    }
    while ( Args_Ok && ( i < argc ) );


  if ( Args_Ok ) {

    Reseau = Read_Network( File_Name );

    if ( Reseau != NULL ) {

      if ( Determinize )
	Flatten = TRUE;

      if ( Flatten )
	Reseau = Flatten_PN( Reseau, Expand_Names );

      if ( Determinize )
	Determinize_PN( Reseau );

      Write_PN_As_PNL( Reseau, Code_File_Name, TOOLNAME );

      return 0;
    }
    else {
      fprintf( stderr, "%s: Error reading network. No translation.\n", 
	       TOOLNAME );
      return -1;
    }
  }

  else if (!Help)
    return -1;
  else
    return 0;
}

void	Determinize_PN( 
PetriNet	*Reseau )
{
  int		i;
  double	The_Mean;

  for ( i=0; i<Reseau->Nb_Trans; i++ ) {
    The_Mean = Mean( Reseau->T[i].Tr_Law );
    Reseau->T[i].Tr_Law->Name = 'C';
    Reseau->T[i].Tr_Law->Parameters[0] = The_Mean;
  }
  for ( i=0; i<Reseau->Nb_Places; i++ ) {
    The_Mean = Mean( Reseau->P[i].Pl_Law );
    Reseau->P[i].Pl_Law->Name = 'C';
    Reseau->P[i].Pl_Law->Parameters[0] = The_Mean;
  }
}

