#include <stdio.h>
#include <bool.h>

#define NB_TRANS	16
#define NB_PLACES	10
#define BUF_SIZE	102

extern int     Y[BUF_SIZE][NB_TRANS];
extern int     Z[BUF_SIZE][NB_TRANS];
extern int	EQ_Time;
extern void	Increment();
extern char	*Next_Departure();
extern void	Arrival( int Dest, double Time );

void dump_YZ( int Real_Time )
{
  int	i;
  int	T;

  T = Real_Time % BUF_SIZE;

  printf("%2d:", Real_Time );

  for ( i=0; i<NB_TRANS; i++ ) {
    printf("%2d/%2d ", Y[T][i], Z[T][i] );
  }
  printf("\n");
}

bool	Trace;

main(int argc, char *argv[]) {

  int	Ok = 1;
  int	Dest;

  if ( ( argc > 1 ) && ( !strcmp ( argv[1], "-trace" ) ) )
    Trace = TRUE;

  while( Ok ) {
    Ok = ( 1 == scanf( "%d", &Dest ) );

    if ( Ok ) {
      if ( Dest == -1 ) {
	Increment();
	(void)Next_Departure();
	dump_YZ( EQ_Time-1 );
      }
      else
	Arrival( Dest, 0.0 );
    }
  }
  return 0;
}
  
